﻿<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
    <title>Bing Map Route</title>
    <style type="text/css">
        .style1
        {
            height: 75px;
            background-color: #eaeaea;
        }
        .container
        {
            border: 1px solid #a6a6a6;
        }
        .container ul
        {
            padding: 0px;
        }
        .container li
        {
            list-style-type: none;
        }
        
        .bulletcont
        {
            list-style-type: none;
            float: left;
            padding: 1px;
            width: 21px;
            margin:0px;
        }
        .bulletdesk
        {
            margin-left: 0px; 
        }
        .bullet
        {
            background: url(images/DepartAriveIcon.png) no-repeat;
            list-style-type: none;
            margin-left: 10px;
            width: 22px;
            height: 22px;
            text-align: center;
        }
        .bullet span
        {
            font-family: Arial, Helvetica, sans-serif;
            font-weight: bold;
            color: #FFFFFF;
            font-size: 14px;
            text-align: center;
            display: block;
            padding: 2px 1px 0px 0px;
        }
        .departhead
        {
            text-transform: uppercase;
            font-size: 11px;
            font-family: Arial, Helvetica, sans-serif;
            padding-left: 40px;
        }
        .desc
        {
            font-family: Arial, Helvetica, sans-serif;
            font-size: 11px;
            font-weight: bold;
            padding-left: 40px;
        }
    </style>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <script type="text/javascript" src="https://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0&s=1"></script>
	<script src="../../ClientGlobalContext.js.aspx" type="text/javascript"></script>
	<script src="/Webresources/a422_jquery.js" type="text/javascript"></script>
	<script src="/Webresources/a422_json2.js" type="text/javascript"></script>
    <script type="text/javascript">
///////////////////////////////////////////////
//The methods in this block are used to make sure the Bing Maps library is loaded before attempting to use the methods
///////////////////////////////////////////////
var LazyMapLoader = new function(){
    var _callback = null, _isLoading = false;

    /******************
 * Private Methods
 ******************/
    function loadJSFile(file)
    {
        var script = document.createElement("script");
        script.setAttribute("type", "text/javascript");
        script.setAttribute("src", file);
        document.body.appendChild(script);
    }

    function isLoaded(){
        return typeof(Microsoft) != 'undefined'
            && typeof(Microsoft.Maps) != 'undefined'
            && typeof(Microsoft.Maps.Map) != 'undefined';
    }

    /******************
 * Public Methods
 ******************/

    this.LoadMapControl = function(culture, callback){
        var loaded = isLoaded();
        if(!_isLoading && !loaded){
            _callback = callback;
            _isLoading = true;

            if(culture == null || culture == ''){
                culture = 'en-US';
            }

            loadJSFile("https://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0&mkt=" + culture);
            setTimeout('LazyMapLoader.__LoadCallback();', 100);
        }else if(loaded){
            _callback();
        }
    };

    this.IsLoaded = function(){
        return isLoaded();
    };

    this.__LoadCallback = function(){
        if(isLoaded()){
            _callback();
            _isLoading = false;
        }else{
            setTimeout('LazyMapLoader.__LoadCallback();', 100);
        }
    };
};
/////////////////////////////////////////////


        var map = null;
        //var MM = Microsoft.Maps;
        var addressList = new Array();
        var orgList = new Array();
        var addressCount = 0;
        var routeString = '';
        var routeStringForPrint = '';
        var key = "AidouiG_1BA_oZJPRHKw6s7c8F7wJzJJmquPv8gUcqfoxlkvtgT-ZSDjWsVq6hct"; //AdmissionLab Key
        var tripId;
        var alphabets = new Array("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");
        
		function LoadMapControl(){
            if(!LazyMapLoader.IsLoaded())
            {
                LazyMapLoader.LoadMapControl('en-US',ShowTripRoute);
            }else if(map == null){
                ShowTripRoute();
            }
        }
		
		function ShowTripRoute() {
            GetAddresses();
            if (addressList.length > 0) {
                GetMap();
            }
        }
        //Test Method.
        function GetAddresses1() {
            addressList[0] = "Barking Station";
            addressList[1] = "IG3 8LQ,London";
            addressList[2] = "Ilford Station";
            orgList[0] = "JK University";
            orgList[1] = "Oxford University";
            orgList[2] = "Essex University";
        }

		//Call web service to get event addresses
		function GetAddresses()
		{
		//Call Web Service to get addresses
		tripId = GetTripId();
		if (tripId != null && tripId != undefined) 
			{
			var context = GetGlobalContext();
			var serverUrl = context.getServerUrl();
			var ODataPath = serverUrl + "/XRMServices/2011/OrganizationData.svc";
			//Query to get data for related activities
			var ODataQuery = ODataPath + "/A422_eventSet?$select=A422_Address,A422_name,a422_organizationid&$filter=a422_tripid/Id eq guid'" + tripId + "'&$orderby=A422_StartDateTime asc";
			
			$.ajax({
			   type: "GET",
			   contentType: "application/json; charset=utf-8",
			   datatype: "json",
			   async: false,
			   url: ODataQuery,
			   beforeSend: function (XMLHttpRequest) { XMLHttpRequest.setRequestHeader("Accept", "application/json"); },
			   success: function (data, textStatus, XmlHttpRequest)
				   {
						var results = data.d.results;
						var msg = "";
						var j = 0;
						//debugger
						for (i = 0; i < results.length; i++) {
							if (results[i].A422_Address != null && results[i].A422_Address != undefined) {
								addressList[j] = results[i].A422_Address;
								orgList[i] = results[i].a422_organizationid.Id;
								j++;
							}
						}
				   },
				   error: function (XmlHttpRequest, textStatus, errorThrown) { document.write('Travel Event call failed: ' + ODataQuery); }
				   });
			}
		}
		
        //function to read the Trip id from Query string.
        function GetTripId() {
            var query = window.location.search.substring(1);
			query = decodeURIComponent(query);
			var name = "id";
			if (query.indexOf("?") == 0) { query = query.substr(1); }
			var pairs = query.split("&");
			for (var i = 0; i < pairs.length; i++) {
				var pair = pairs[i].split("=");
				if (pair[0] == name) {
					return pair[1];
				}
			}
			return "";
        }

        function GetMap() {
            // Initialize the map
            map = new Microsoft.Maps.Map(document.getElementById("mapDiv"), { credentials: key, mapTypeId: "r" });
            //ClickGeocode();
            ClickRoute();
        }

        function ClickRoute(credentials) {

            map.getCredentials(MakeRouteRequest);
        }


        function MakeRouteRequest(credentials) {
            //var routeString = '';

            for (var j = 0; j < addressList.length; j++) {
                routeString = routeString + "wp." + j + "=" + addressList[j] + "&"
                routeStringForPrint = routeStringForPrint + "wp." + j + "=" + addressList[j] + "~";
                //alert(routeString);
            }
            routeString = routeString.substring(0, routeString.length - 1);
            routeStringForPrint = routeStringForPrint.substring(0, routeStringForPrint.length - 1);
            var routeRequest = "https://dev.virtualearth.net/REST/v1/Routes?" + routeString + "&routePathOutput=Points&output=json&distanceUnit=Mile&jsonp=RouteCallback&key=" + credentials;

            CallRestService(routeRequest);

        }


        function RouteCallback(result) {


            if (result &&
                   result.resourceSets &&
                   result.resourceSets.length > 0 &&
                   result.resourceSets[0].resources &&
                   result.resourceSets[0].resources.length > 0) {

                // Set the map view
                var bbox = result.resourceSets[0].resources[0].bbox;
                var viewBoundaries = Microsoft.Maps.LocationRect.fromLocations(new Microsoft.Maps.Location(bbox[0], bbox[1]), new Microsoft.Maps.Location(bbox[2], bbox[3]));
                map.setView({ bounds: viewBoundaries });

                for (var x = 0; x < result.resourceSets[0].resources[0].routeLegs.length; x++) {
                    // Add a pushpin at the found location
                    var location = new Microsoft.Maps.Location(result.resourceSets[0].resources[0].routeLegs[x].startLocation.point.coordinates[0], result.resourceSets[0].resources[0].routeLegs[x].startLocation.point.coordinates[1]);
                    InsertPushpin(location, x);
                    if (x == result.resourceSets[0].resources[0].routeLegs.length - 1) {
                        var locationEnd = new Microsoft.Maps.Location(result.resourceSets[0].resources[0].routeLegs[x].endLocation.point.coordinates[0], result.resourceSets[0].resources[0].routeLegs[x].endLocation.point.coordinates[1]);
                        InsertPushpin(locationEnd, x + 1);
                    }
                }

                // Draw the route
                var routeline = result.resourceSets[0].resources[0].routePath.line;
                var routepoints = new Array();

                for (var i = 0; i < routeline.coordinates.length; i++) {

                    routepoints[i] = new Microsoft.Maps.Location(routeline.coordinates[i][0], routeline.coordinates[i][1]);
                }


                // Draw the route on the map
                var routeshape = new Microsoft.Maps.Polyline(routepoints, { strokeColor: new Microsoft.Maps.Color(200, 0, 0, 200) });
                map.entities.push(routeshape);

                //Draw the instructions-points
                var directions; // = result.resourceSets[0].resources[0].routeLegs[0].itineraryItems;
                var totalDistance = 0.0;
                var totalTime = 0.0;
                var alertMsg = '';
                var ind = 0;
                var tripLocs = result.resourceSets[0].resources[0].routeLegs.length;
                //debugger
                alertMsg = alertMsg + '<table style="width:100%;font-family: Arial; font-size:11px;" class="container">';
                for (var x = 0; x < result.resourceSets[0].resources[0].routeLegs.length; x++) {
                    var twoLocsDistance = 0.0;
                    var twoLocsTime = 0.0;
                    var directionsMsg = '';

                    alertMsg = alertMsg + '<tr><td  class="style1" colspan="2"><ul class="bulletcont"><li class="bullet"><span>' + alphabets[x] + '</span></li></ul><ul class="bulletdesk"><li class="departhead">DEPART:</li><li class="desc">' + orgList[x] + '</li><li class="desc">' + addressList[x] + '</li></ul></td></tr>';
                    directions = result.resourceSets[0].resources[0].routeLegs[x].itineraryItems
                    for (var i = 0; i < directions.length; i++) {
                        var indDirDistance;
                        if (directions[i].travelDistance.toFixed(1) == 0.0) {
                            indDirDistance = directions[i].travelDistance.toFixed(2);
                        }
                        else
                            indDirDistance = directions[i].travelDistance.toFixed(1);

                        if (i + 1 == directions.length)
                            directionsMsg = directionsMsg + '<tr><td colspan="2" ><br /><a style="color:Green; padding-right:1px">' + (ind + 1).toString() + '.</a>' + directions[i].instruction.text + '</td></tr>';
                        else
                            directionsMsg = directionsMsg + '<tr><td width="80%"><br /><a style="color:Green; padding-right:1px">' + (ind + 1).toString() + '.</a>' + directions[i].instruction.text + '</td><td align="left" width="20%"><a>' + '(' + indDirDistance + ' mi)</a></td></tr>';
                        //directionsMsg = directionsMsg + (ind + 1).toString() + "." + directions[i].instruction.text + "(" + indDirDistance + "mi)<br><br>";
                        //directionsMsg = directionsMsg + '<tr><td><br /><a style="color:Green; padding-right:1px">' + (ind + 1).toString() + '.</a>' + directions[i].instruction.text + '<a style="padding-left:100px">'+ '(' + indDirDistance + ' mi)</a></td></tr>';
                        totalDistance = totalDistance + parseFloat(directions[i].travelDistance);
                        totalTime = totalTime + parseFloat(directions[i].travelDuration);
                        twoLocsDistance = twoLocsDistance + parseFloat(directions[i].travelDistance);
                        twoLocsTime = twoLocsTime + parseFloat(directions[i].travelDuration);
                        var dispTime = Math.floor(twoLocsTime / 60) + " min," + (twoLocsTime % 60).toFixed().pad(2, "0") + " sec"; 
                        ind++;
                    }
                    alertMsg = alertMsg + '<tr><td colspan="2"><a style="color:Green">' + alphabets[x] + '-' + alphabets[x + 1] + ':</a>' + twoLocsDistance.toFixed(1) + ' mi<a style="color:Green; padding-left:10px">Estimated time:' + dispTime + '</a></td></tr>';
                    alertMsg = alertMsg + directionsMsg;
                    alertMsg = alertMsg + '<tr><td  class="style1" colspan="2"><ul class="bulletcont"><li class="bullet"><span>' + alphabets[x + 1] + '</span></li></ul><ul class="bulletdesk"><li class="departhead">ARRIVE:</li><li class="desc">' + orgList[x + 1] + '</li><li class="desc">' + addressList[x + 1] + '</li></ul></td></tr>';
                    if ((x + 1) != result.resourceSets[0].resources[0].routeLegs.length)
                        alertMsg = alertMsg + '<tr style="height:15px"><td colspan="2"></td></tr><tr>';
                }
                //alertMsg = alertMsg + "Total Distance: " + totalDistance.toFixed(1) + "km \t Total Time: " + totalTime + "s"
                //                  alertMsg = alertMsg + "<b style='color:Blue'>" + orgList[tripLocs] + "</b><br>";
                //                  alertMsg = alertMsg + "<a>" + addressList[tripLocs] + "</a><br><br>";
                alertMsg = alertMsg + '</table>';
                var directionsDiv = document.getElementById('directionsDiv');
                //var TotalRoute = "<div style='background-color:lightgray;width:100%;position:absolute;top:30px;'><b style='color:Green;'>Route:</b><b>" + totalDistance.toFixed(1) + "mi," + totalTime + "s</b><br></div>";
                //alertMsg = TotalRoute + alertMsg;
                directionsDiv.innerHTML = alertMsg;

            }
        }
        String.prototype.pad = function (l, s) {
            return (l -= this.length) > 0
        ? (s = new Array(Math.ceil(l / s.length) + 1).join(s)).substr(0, s.length) + this + s.substr(0, l - s.length)
        : this;
        };

        function InsertPushpin(location,x) {
			var pushpin = new Microsoft.Maps.Pushpin(location);
            var pushpinOptions = { icon: 'images/pin.png',
                anchor: new Microsoft.Maps.Point(10, 10),
                text: alphabets[x]
            };
            pushpin.setOptions(pushpinOptions);
            Microsoft.Maps.Pushpin.prototype.title = null;
            pushpin.title = orgList[x];  //orgList[addressCount];  //result.resourceSets[0].resources[0].name;
            Microsoft.Maps.Pushpin.prototype.description = null;
            pushpin.description = addressList[x];  //result.resourceSets[0].resources[0].name;

            //Add handler for the pushpin click event.
            Microsoft.Maps.Events.addHandler(pushpin, 'click', displayEventInfo);

            map.entities.push(pushpin);
        }
//        function ClickGeocode() {
//            for (var i = 0; i < addressList.length; i++) {
//                var geocodeRequest = "http://dev.virtualearth.net/REST/v1/Locations/" + addressList[i] + "?output=json&jsonp=GeocodeCallback&key=" + key;
//                CallRestService(geocodeRequest);
//            }
//        }


//        function GeocodeCallback(result) {
//            //alert("Found location: " + result.resourceSets[0].resources[0].name);
//            if (result &&
//                   result.resourceSets &&
//                   result.resourceSets.length > 0 &&
//                   result.resourceSets[0].resources &&
//                   result.resourceSets[0].resources.length > 0) {
//                // Set the map view using the returned bounding box
//                var bbox = result.resourceSets[0].resources[0].bbox;
//                var viewBoundaries = Microsoft.Maps.LocationRect.fromLocations(new Microsoft.Maps.Location(bbox[0], bbox[1]), new Microsoft.Maps.Location(bbox[2], bbox[3]));
//                map.setView({ bounds: viewBoundaries });

//                // Add a pushpin at the found location
//                var location = new Microsoft.Maps.Location(result.resourceSets[0].resources[0].point.coordinates[0], result.resourceSets[0].resources[0].point.coordinates[1]);
//                var pushpin = new Microsoft.Maps.Pushpin(location);
//                var pushpinOptions = { icon: './imgs/pin.png',
//                    anchor: new MM.Point(10, 10),
//                    text: alphabets[addressCount]
//                };
//                pushpin.setOptions(pushpinOptions);
//                Microsoft.Maps.Pushpin.prototype.title = null;
//                pushpin.title = orgList[addressCount];  //orgList[addressCount];  //result.resourceSets[0].resources[0].name;
//                Microsoft.Maps.Pushpin.prototype.description = null;
//                pushpin.description = addressList[addressCount];  //result.resourceSets[0].resources[0].name;

//                //Add handler for the pushpin click event.
//                Microsoft.Maps.Events.addHandler(pushpin, 'click', displayEventInfo);

//                map.entities.push(pushpin);
//                addressCount++;

//            }
//        }
        function displayEventInfo(e) {
            if (e.targetType = "pushpin") {
                var pix = map.tryLocationToPixel(e.target.getLocation(), Microsoft.Maps.PixelReference.control);
                var infoboxTitle = document.getElementById('infoboxTitle');
                infoboxTitle.innerHTML = e.target.title;
                var infoboxDescription = document.getElementById('infoboxDescription');
                infoboxDescription.innerHTML = e.target.description;
                var infobox = document.getElementById('infoBox');
                infobox.style.top = (pix.y - 60) + "px";
                infoBox.style.left = (pix.x + 5) + "px";
                infoBox.style.visibility = "visible";
                document.getElementById('mapDiv').appendChild(infoBox);
            }
        }

        function closeInfoBox() {
            var infobox = document.getElementById('infoBox');
            //if(infoBox.style.visibility=="visible")
            infoBox.style.visibility = "hidden";
        }

        function CallRestService(request) {
            var script = document.createElement("script");
            script.setAttribute("type", "text/javascript");
            script.setAttribute("src", request);
            document.body.appendChild(script);
        }
        function PrintMap() {

            if (routeStringForPrint != '' && routeStringForPrint != undefined) {

                //window.open("http://dev.virtualearth.net/REST/v1/Imagery/Map/Road/Routes?" + routeString + "&mapVersion=v1&mapSize=800,600&zoomLevel=15&key=" + key, "", "width=1000,height=800", "");
                //window.open("./Print.aspx?RouteStr=" + routeStringForPrint, "", "width=1000,height=800", "");
                //window.open("/ISV/AdmissionsLab/TravelManagement/Print.aspx?RouteStr=" + routeStringForPrint + "&tripId=" + tripId, "", "", "");
                //window.open("/WebResources/a422_/Travel/PrintRoute.html?RouteStr=" + routeStringForPrint + "&tripId=" + tripId, "", "", "");
				window.open("/WebResources/a422_/Travel/PrintRoute.html?Data=" + tripId);
            }
        }


    </script>
</head>
<body onload="LoadMapControl();">
    <div id='mapDiv' style="position: absolute; width: 66%; height: 98%; right: 0px;
        top: 0px; overflow: auto;">
    </div>
    <div style="position: relative; overflow: auto; height: 2%; width: 32%;">
        <input type="button" value="Print" onclick="PrintMap();" />
        <img src="images/close.jpg" alt="close" onclick="document.getElementById('directions').style.visibility = 'hidden';document.getElementById('mapDiv').style.width = '98%';"
            style="position: absolute; left: 90%;" />
    </div>
    <div id='directions' style="position: absolute; width: 32%; height: 96%; overflow: auto;">
        <%--<img src="./imgs/close.jpg" alt="close" onclick="document.getElementById('directions').style.visibility = 'hidden';document.getElementById('mapDiv').style.width = '98%';" style="position:absolute; right:17px;" />--%>
        <div id='directionsDiv' style="position: absolute; width: 100%; height: 96%; overflow: auto;
            font-size: 11px;">
        </div>
    </div>
    <div id='infoBox' style="visibility: hidden; position: absolute; top: 0px; left: 0px;
        width: 300px; z-index: 10000; font-family: Arial; font-size: 11px;">
        <div id='infoboxText' style="background-color: White; border-style: solid; border-width: medium;
            border-color: DarkOrange; min-height: 100px; position: absolute; top: 0px; left: 23px;
            width: 280px;">
            <b id='infoboxTitle' style="position: absolute; top: 10px; left: 10px; width: 260px;
                font-size: 11px;"></b>
            <img src="images/close.jpg" alt="close" onclick="closeInfoBox()" style="position: absolute;
                top: 10px; right: 10px;" />
            <a id='infoboxDescription' style="position: absolute; top: 30px; left: 10px; width: 260px;
                font-size: 11px; color: Gray;"></a>
        </div>
    </div>
</body>
</html>
